/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// SignedTx struct for SignedTx
type SignedTx struct {
	// The signed TX.
	Tx string `json:"tx"`
}

// NewSignedTx instantiates a new SignedTx object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSignedTx(tx string) *SignedTx {
	this := SignedTx{}
	this.Tx = tx
	return &this
}

// NewSignedTxWithDefaults instantiates a new SignedTx object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSignedTxWithDefaults() *SignedTx {
	this := SignedTx{}
	return &this
}

// GetTx returns the Tx field value
func (o *SignedTx) GetTx() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Tx
}

// GetTxOk returns a tuple with the Tx field value
// and a boolean to check if the value has been set.
func (o *SignedTx) GetTxOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Tx, true
}

// SetTx sets field value
func (o *SignedTx) SetTx(v string) {
	o.Tx = v
}

func (o SignedTx) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["tx"] = o.Tx
	}
	return json.Marshal(toSerialize)
}

type NullableSignedTx struct {
	value *SignedTx
	isSet bool
}

func (v NullableSignedTx) Get() *SignedTx {
	return v.value
}

func (v *NullableSignedTx) Set(val *SignedTx) {
	v.value = val
	v.isSet = true
}

func (v NullableSignedTx) IsSet() bool {
	return v.isSet
}

func (v *NullableSignedTx) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSignedTx(val *SignedTx) *NullableSignedTx {
	return &NullableSignedTx{value: val, isSet: true}
}

func (v NullableSignedTx) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSignedTx) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
